@use "sass:math";

/*
*  Elements that can be changed will hint this by dimming and fading a little on hover
*/
@mixin changeable($transition-period, $hover-brightness, $hover-opacity, $hover-color: null) {
  transition: filter $transition-period;
  cursor: pointer;

  &:hover {
    filter: brightness($hover-brightness);
    opacity: $hover-opacity !important;
    @if $hover-color {
      color: $hover-color;
    }
  }
}

/*
 * Toothradio. Some (eg trauma) are not changeable, hence the option.
 */
@mixin toothradio($width, $height, $unchecked_background: #FFF, $checked_background: lighten($red, 35%), $changeable: true) {

  display: flex;
  gap: .2rem;

  label {

    & {
      height: $height;
      width: $width;
      border: 1px solid $red;
      background-color: $checked_background;

      &:last-of-type {
        margin-right: 0px;
      }

      &[for$="-0"] {
        width: auto;
        height: auto;
        color: $almost_white;
        background: none !important;
        border: none;
        font-size: 0.6rem;
      }

      @if $changeable {
        @include changeable(0.1s, 0.8, 0.9);
      } @else {
        cursor: not-allowed;
      }
    }
  }

  /* Hide the browser's default checkbox */
  input {

    display: none;

    &:checked {

      & ~ label {
        background-color: $unchecked_background;
      }

      & + label {
        background-color: $checked_background;
      }
    }
  }
}

/*
 * Custom Radio
 */
@mixin custom_radio($width, $height) {

  display: flex;
  $default_color: $almost_black;
  $accent_color: $almost_black;
  $circle_border_color: $almost_black;

  label {

    height: $height;
    width: $width;
    background-color: $accent_color;
    margin-right: .2rem;

    vertical-align: middle;
    border-radius: 24px;

    &[for$="-0"] {
      width: auto;
      height: auto;
      color: $red;
      background: none !important;
      border: none;
      font-size: 0.7rem;
    }

    @include changeable(0.1s, 0.7, 0.4);
  }

  /* Hide the browser's default checkbox */
  input {
    display: none;

    &:checked {
      & ~ label {
        opacity: 0.15;
      }

      & + label {
        opacity: 1;
      }
    }
  }
}

/*
 * Custom Radio Squared
 */
@mixin custom_radio_square($side, $gap:0) {

  display: grid;
  gap: $gap;
  $default_color: #FFF;
  $accent_color: lighten($red, 35%);
  $circle_border_color: $red;

  label {

    & {
      height: $side;
      width: $side;
      background-color: $accent_color;
      border: 1px solid $circle_border_color;

      @include changeable(0.1s, 0.8, 0.9);
    }
  }

  /* Hide the browser's default checkbox */
  input {
    display: none;

    &:checked {

      & ~ label {
        background-color: $default_color;
      }

      & + label {
        background-color: $accent_color;
      }
    }

    &:disabled {
      & ~ label {
        background-color: $lightgray;
        cursor: not-allowed;
      }
    }
  }
}

/*
 * Checkboxes underscored.
 */
@mixin check_underscore() {

  display: flex;
  flex-wrap: wrap;
  label {
    cursor: pointer;
    font-size: 19px;
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
    user-select: none;
    margin-right: 10px;
    @include changeable(0.1s, 0.8, 0.9);

    /* Hide the browser's default checkbox */
    input {

      display: none;

      &:checked ~ .checkmark {
        color: $red;
      }
    }

    .checkmark {
      text-decoration: none;
      font-weight: bold;
    }
  }

}

/*
 * Create Clock
 */
@mixin clock($segments, $size, $default_color:null, $accent_color:null) {

  $angle: math.div(360, $segments);
  $skew: 90 + $angle;
  $border_width: 3;

  position: relative;

  .blades-clock {

    position: relative;
    @if $default_color {
      border: #{$border_width}px solid $almost_black;
    }
    padding: 0;
    width: #{$size}px;
    height: #{$size}px;
    border-radius: 50%;
    list-style: none;
    overflow: hidden;
    background-size: cover;

    label {
      overflow: hidden;
      position: absolute;
      top: -50%;
      right: -50%;
      width: 100%;
      height: 100%;
      transform-origin: 0% 100%;
      background-color: $accent_color;

      @include changeable(0.1s, 0.8, 0.9);
    }

    input {
      position: absolute;
      display: none;

      &:checked {
        & ~ label {
          @if $default_color {
            background-color: $default_color;
          }
        }

        & + label {
          @if $accent_color {
            background-color: $accent_color;
          }
        }
      }
    }

    // Zero value to clear everything.
    input[value="0"] {
      display: none;
    }

    @for $i from 1 through $segments {

      $rotate_angle: $angle * ($i - 1);
      *:nth-child(#{$i * 2 + 1}) {
        transform: rotate(#{$rotate_angle}deg) skewY(#{$skew}deg);
      }
    }
  }

}

/*
 * Turf Block
 */
@mixin turf_block($turf_width, $turf_height) {
  @include changeable(0.1s, 0.8, 0.9);


  $turf_margin: 20px;
  $connector_height: math.div($turf_height, 10);
  $connector_width: $turf_margin * 2;

  width: $turf_width;
  height: $turf_height;
  background-color: $lightgray;
  position: relative;
  margin: $turf_margin;
  flex-grow: initial;

  &.turf-selected {
    .connector {
      background-color: $gray;
      z-index: 1;
    }
  }

  .connector {

    position: absolute;
    display: block;
    background-color: $lightgray;

    &.right,
    &.left {
      width: $turf_margin * 2;
      height: math.div($turf_height, 5);
      top: math.div($turf_height, 2) - math.div($turf_height, 10);
    }

    &.left {
      left: -$turf_margin * 2;
    }

    &.right {
      left: $turf_width;
    }

    &.top,
    &.bottom {
      height: $turf_margin * 2;
      width: math.div($turf_height, 5);
      left: math.div($turf_width, 2) - math.div($turf_height, 10);
    }

    &.top {
      top: -$turf_margin * 2;
    }

    &.bottom {
      top: $turf_height;
    }
  }


  &.turf-selected {
    background-color: $gray;
  }

  .turf-description {
    border: none;
    background: none;
    resize: none;
    width: $turf_width;
    text-align: center;
    min-height: auto;
    font-size: 12px;
  }

  .turf-name {
    border: none;
    border-radius: 0px;
    text-align: center;
    font-weight: bold;
  }

  input[type="checkbox"] {
    transform: scale(1);
  }

  .turf-control {
    &.turf-select {
      position: absolute;
      top: -7px;
      left: -7px;
    }
  }
}


/*
 * Toothradio single elements
 */
@mixin toothradio_single($width, $height, $unchecked_background, $checked_background) {

  display: flex;

  label {
    @include changeable(0.1s, 0.8, 0.9);

    & {
      height: $height;
      width: $width;
      background-image: url($unchecked_background);
      background-repeat: no-repeat;
      background-size: contain;
      margin-right: 5px;

      &:last-of-type {
        margin-right: 0px;
      }
    }
  }

  /* Hide the browser's default checkbox */
  input {

    display: none;

    &:checked {
      & + label {
        background-image: url($checked_background);
      }
    }
  }
}

/*
 * Custom Radio Round
 */
@mixin custom_radio_round($diameter, $circle_border_color, $default_color, $accent_color) {

  display: flex;

  label {
    @include changeable(0.1s, 0.8, 0.9);

    &:not([for$="-0"]) {
      height: $diameter;
      width: $diameter;
      background-color: $accent_color;

      vertical-align: middle;
      border: 2px solid $accent_color;
      border-radius: math.div($diameter, 2);
    }
  }

  /* Hide the browser's default checkbox */
  input {
    display: none;

    &:checked {
      & ~ label:not([for$="-0"]) {
        border-color: $circle_border_color;
        background-color: $default_color;
      }

      & + label:not([for$="-0"]) {
        background-color: $accent_color;
        border-color: $accent_color;
      }
    }
  }
}

@mixin custom_checkbox($size, $color, $acent-color, $position: 'left') {
  position: relative;
  width: 100%;
  input {
    position: absolute;
    opacity: 0;
    height: 0;
    width: 0;
  }
  .checkmark {
    position: absolute;
    top: 0;
    width: $size;
    height: $size;
    background-color: $color;
    border: 1px solid $acent-color;
    cursor: pointer;
    @if $position == 'left' {
      right: 0;
    } @else {
      left: 0;
    }
  }
  &:hover input ~ .checkmark {
    background-color: lighten($acent-color, 35%)
  }
  input:checked ~ .checkmark {
    background-color: $acent-color;
  }
}

@mixin resource_list($columns) {
  %resource_active {
    background-color: $red;
    color: white;
  }
  --amount: #{$columns};
  --counter: 1;
  display: grid;
  grid-template-columns: repeat(var(--amount), 1fr 2fr) 1fr;
  grid-gap: .5rem 1rem;

  .resource {
    position: relative;
    grid-column: 1 / span 3;
    grid-row: calc(var(--counter) + var(--counter)) / span 2;
    height: 0;
    padding-bottom: 85%;

    &::before {
      content: "";
      width: 50%;
      height: 100%;
      float: left;
      shape-outside: polygon(0% 0%, 25% 0%, 0 50%, 25% 100%, 0% 100%);
    }

    // Columns
    @for $i from 1 through $columns {
      &:nth-of-type(#{$columns}n + #{$i}) {
        grid-column: #{$i + $i - 1} / span 3;
        @if $i % 2 == 0 {
          grid-row: calc(var(--counter) + var(--counter) - 1) / span 2;
        }
      }
    }

    // Rows
    @for $i from 1 through 20 {
      &:nth-of-type(n + #{$i * $columns + 1}) {
        --counter: #{$i + 1};
      }
    }

    &__content {

      .shape {
        width: 25%;
        height: 100%;
        shape-outside: polygon(0% 0%, 100% 0%, 0 50%, 100% 100%, 0% 100%);
        shape-margin: .4rem;
        float: left;
        background: #444;
        clip-path: polygon(0% 0%, 100% 0%, 0 50%, 100% 100%, 0% 100%);

        &.right {
          clip-path: polygon(0 0, 100% 0, 100% 100%, 0 100%, 100% 50%);
          shape-outside: polygon(0 0, 100% 0, 100% 100%, 0 100%, 100% 50%);
          float: right;
        }
      }

      z-index: 2;
      position: absolute;
      display: flex;
      flex-direction: column;
      justify-content: center;
      align-items: center;
      padding: 1rem 10%;
      left: 0;
      top: 0;
      height: 100%;
      width: 100%;
      background-color: $pink;

      clip-path: polygon(75% 0, 100% 50%, 75% 100%, 25% 100%, 0 50%, 25% 0);
      text-align: center;
      cursor: pointer;

      p {
        &.title {
          @extend h4;
          text-transform: uppercase;
          margin-bottom: .2rem;
          font-size: .8rem;
        }

        font-size: .6rem;
        margin: 0;
      }
    }

    &.acquired, &.base {
      .resource__content {
        @extend %resource_active;
      }
    }

    &:not(.editable):not(.base):not(.acquired) {
      .resource__content {
        &:hover {
          @extend %resource_active;
          background-color: lighten($red, 10%);
        }
      }
    }

    .connector {
      $Y: 15px;
      --transX: 0;
      --transY: -#{$Y};
      --rotation: 0deg;
      position: absolute;
      background: $pink;
      width: 10px;
      height: 100%;
      transform: rotate(var(--rotation)) translate(var(--transX), var(--transY));
      z-index: 1;
      left: 50%;

      &.top, &.bottom {
        --transX: -50%;
      }

      &.topRight {
        --rotation: 60deg;
      }

      &.bottomLeft {
        --rotation: 60deg;
        --transY: #{$Y};
      }

      &.topLeft {
        --rotation: -60deg;
      }

      &.bottomRight {
        --rotation: -60deg;
        --transY: #{$Y};
      }

      &.bottom {
        --transY: #{$Y};
      }


    }
  }
}
